
// include the library code:

// контроль нуля идет на 1-е прерывание (это pin 3)
// Управление симистором реализовано через PIN 11
// АЦП от трансформатора подключен на      pin А3


#include <LiquidCrystal.h>

#define MAX_INDEX_INPUT 128

unsigned int data_adc[MAX_INDEX_INPUT+1];
unsigned int tic_adc[MAX_INDEX_INPUT+1];

// initialize the library with the numbers of the interface pins
// Ну это понятно, это подключен LCDs
LiquidCrystal lcd(52,50, 48, 46, 44, 42);
int MaxVolts;

#define PIN_TRIAC  11    // Управление симистором реализовано через PIN 11


int Counter1=0;
unsigned int Seconds;
char NeedDisplaying;
int result;
unsigned int CountTimer3=0;
unsigned int CompA3=16;      // Текущее значение для периодического вызова таймера 3.
unsigned char StateVolts=0;  // Состояние вычисление среднеквадратичного 
//0 - надо вычислить - запускается старт, 1 - вычисляется, 2 - вычислено, 3 - идет обработка рузультата
// 4 - Результат обработан, можно вычислять следующий
unsigned int index_input=0; // Текущий размер массива дла расчета среднеквадратичного

unsigned int SquareNapr;
char flFirstZero=1;
//unsigned int VoltsZr;
unsigned long TekPower;
unsigned int TimeOpenTriac=0;

// Установка мощности (Пока в виде переменных)

int Power=1000;       // Номинальная мощность ТЭНов
int UstPower=100;     // Нужно получить мощность от регулятора

void setup() 
{
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  // Print a message to the LCD.
//  lcd.print("hello, world!");
  analogReference(DEFAULT);

  pinMode(PIN_TRIAC, OUTPUT);
  digitalWrite(PIN_TRIAC, HIGH);  
  attachInterrupt(1, zero_crosss_int, RISING);  // Устанавливаем на 1-е прерывание функцию (это pin 3)


  // Таймер 2 используется для подсчета числа секунд и, возможно, программного небыстрого ШИМа
  // Прерываение по этому таймеру будет вызываться 125 раз в секунду.
  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: 62,500 kHz
  // Mode: Normal top=0xFF
  // OC2A output: Disconnected
  // OC2B output: Disconnected
  TCCR2A=0x00;
  TCCR2B=0x07;
  TCNT2=0x00;
  OCR2A=0x7D;
  OCR2B=0x00;  
  //  // Timer/Counter 1 Interrupt(s) initialization
  TIMSK2=0x02;


  // Таймер 3 будет использоваться для такой, обычно очень несвойственной для него процедуры, как "замена" аппаратного прерывания АЦП.
  // (даже обидно для этих целей целый таймер задействовать!)
  // Timer/Counter 3 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC3A output: Discon.
  // OC3B output: Discon.
  // OC3C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer3 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR3A=0x00;
  TCCR3B=0x03;
  TCNT3H=0x00;
  TCNT3L=0x00;
  ICR3H=0x00;
  ICR3L=0x00;

  OCR3AH=0;
  OCR3AL=0x7;

  OCR3BH=0x00;
  OCR3BL=0x00;
  OCR3CH=0x00;
  OCR3CL=0x00;  
  // Timer/Counter 3 Interrupt(s) initialization
  TIMSK3=0x02;

  // Таймер 4 будет использоваться для подсчета числа тиков при вызове АЦП в расчете среднеквадратичного 
  // (поскольку непонятно, чего и сколько это занимает в Ардуино - исходный код разбирать неохота)
  // Timer/Counter 4 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC4A output: Discon.
  // OC4B output: Discon.
  // OC4C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer4 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR4A=0x00;
  TCCR4B=0x03;
  TCNT4H=0x00;
  TCNT4L=0x00;
  ICR4H=0x00;
  ICR4L=0x00;
  OCR4AH=0x00;
  OCR4AL=0x00;
  OCR4BH=0x00;
  OCR4BL=0x00;
  OCR4CH=0x00;
  OCR4CL=0x00;
  // Timer/Counter 4 Interrupt(s) initialization
  TIMSK4=0x00;


  // Таймер 5 будет использоваться для управления симистором по прерыванию COMPA.
  // Timer/Counter 5 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC5A output: Discon.
  // OC5B output: Discon.
  // OC5C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer5 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR5A=0x00;
  TCCR5B=0x03;
  TCNT5H=0x00;
  TCNT5L=0x00;
  ICR5H=0x00;
  ICR5L=0x00;
  OCR5AH=0x00;
  OCR5AL=0x02;
  OCR5BH=0x00;
  OCR5BL=0x00;
  OCR5CH=0x00;
  OCR5CL=0x00;
  // Timer/Counter 5 Interrupt(s) initialization
  TIMSK5=0x02;

  TekPower=(unsigned long) UstPower*220*220/ Power;
  
}

// Прерывание управления симистором.
ISR(TIMER5_COMPA_vect) 
{
  // Включаем симистор
  digitalWrite(PIN_TRIAC, HIGH);  
  // ждем 10 мкс и выключаем симистор
  delayMicroseconds(10);       
  digitalWrite(PIN_TRIAC, LOW);  

}

// Прерывание по таймеру 3 для расчета среднеквадратичного
ISR(TIMER3_COMPA_vect) 
{
  unsigned int zn;
  unsigned int tic;
  CountTimer3++; // Это для отладки, чтобы понять, что таймер вызывается и я правильно понял логику таймеров в Ардуино.

  // Здесь проявляется недостаток реалициации АЦП в Ардуино, если даже на Atmega16 c частотой 8Мгц, АЦП, реализованное через аппаратное прерывание успевает стабильно отловить ноль в одном и том же месте
  // то здесь ноль отлавивается в  немного отличающихся местах, на пару десатков тиков таймера.
  // Если бы измерение сетевого напряжения проводилось от резисторного делителя, а не от транформатора, то 0 АЦП соответсвовал бы переходу через 0 контроллера детектора нуля, и было бы проще, а так 
  // надо как-то организовать дополнительно прерывание по 0 именно от напряжения трансформатора, или подумать, как решить это программно.
  
  // Если дана команда начать расчет среднеквадратичного, то читаем значение АЦП.
  if (StateVolts==0 || StateVolts==1)
  {
    result=analogRead(3); // читаем показания с pin А3
  }

  tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера


  if (result==0)
  {

    // Если дана команда рассчитать среднеквадратичное, или среднеквадратичное рассчитывается, но 0 встретился раньше, чем положено, то запускаем расчет заново.        
    if (StateVolts==0 || (StateVolts==1 && index_input<=20))
    {
      index_input=0;
      StateVolts=1; 
      tic=0;  
      MaxVolts=0;
      TCNT4H=0x00;
      TCNT4L=0x00;

    }  

    // Если ноль встретился и процесс расчета идет, тогда ставим флаг окончания процесса.
    if (StateVolts==1 && index_input>40)
    {                
      data_adc[index_input]=result;    
      tic_adc[index_input]= tic;
      index_input++;
      NeedDisplaying=true;
      StateVolts=2;     
    }                 

  }

  // Если процесси идет, тогда просто накапливаем значения измерений
  if (StateVolts==1)
  {
    data_adc[index_input]=result;   
    tic_adc[index_input]=tic;
    index_input++;
    if (result>MaxVolts)
    {  
      MaxVolts=result;
    }
  }


  // Если превышен размер массива, то считаем эту выборку несостоятельной (Вдруг глюк АЦП или помеха в сети), начинаем снова.
  if (index_input>=MAX_INDEX_INPUT)  StateVolts=0;

  // Сбрасываем таймер
  TCNT3H=0x00;
  TCNT3L=0x00;

}


// Прерывание вызывается 125 раз в секунду
ISR(TIMER2_COMPA_vect) 
{

  if (Counter1==62)
  {
    NeedDisplaying=true;
  }

  if (Counter1 % 25 ==0)
  {
    if (StateVolts==4)
    {
      StateVolts=0; // Раз в 1/5 секунды запускаем измерение среднеквадратичного (в дальнейшем надо будет настроить, 
                    // чтобы оно делалось так часто, насколько позволяют возможности контроллера).
    }

    
  }
  Counter1++;
  if (Counter1>=125)
  {
    Seconds++;
    Counter1=0;
    NeedDisplaying=true;

  }
  // Сброс таймера
  TCNT2=0x00;
}


// the interrupt function must take no parameters and return nothing
void zero_crosss_int()  // function to be fired at the zero crossing to dim the light
{
    // Сбрасываем 5-й таймер.
    TCNT5H=0x00;
    TCNT5L=0x00;
    //TimeOpenTriac=2000;
    // В прерывании нуля настраиваем, чтобы прерывание на 5-м таймере выдалось через то время, которое мы ранее рассчитали.
    OCR5AH=(char)(TimeOpenTriac>>8);
    OCR5AL=(char)TimeOpenTriac;
}

void DisplayData()
{
  lcd.setCursor(0, 0);
  lcd.print(Seconds);
  lcd.setCursor(5, 0);
  lcd.print(MaxVolts);
  lcd.setCursor(9, 0);
  // Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
  // это напряжение нужно для калибровки нашего измерителя
  lcd.print((long)MaxVolts*707/1000);
  lcd.setCursor(0, 1);
  lcd.print(index_input);
  lcd.setCursor(5, 1);
  lcd.print(TimeOpenTriac);
  NeedDisplaying=false;
}

void loop() 
{
  int i,j;
  unsigned long SqNapr=0,SqNaprPrev=0,FindPower;

  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображение информации на дисплее и среднеквадратичное уже рассчитано.
  if (NeedDisplaying && StateVolts!=0)
  {
    DisplayData();
  }

  if (StateVolts==2)                 
  {
    StateVolts=3;
    SqNapr=0;
    SqNaprPrev=0;    
    FindPower=TekPower*index_input;
    j=0;
    TimeOpenTriac=0;        

    if (Power>UstPower)
    {
      for(i=index_input-1;i>=0;i--)
      {
        SqNapr=SqNapr+(unsigned long) data_adc[i]* (unsigned long) data_adc[i];
        if (SqNapr>=FindPower) 
        { 
          TimeOpenTriac=tic_adc[i]+ (SqNapr-FindPower)*(tic_adc[i+1]-tic_adc[i])/(SqNapr-SqNaprPrev);
          j=i;
          break;
        }                     
        SqNaprPrev=SqNapr;           
      } 
      StateVolts=4;
    }
  }

}





